﻿using System;
using System.Collections.Generic;
using System.Text;
using NativeWifi;
using System.Threading;
using System.Diagnostics;

namespace autowc
{
    class Program
    {

            /// <summary>
        /// Converts a 802.11 SSID to a string.
        /// </summary>
        static string GetStringForSSID(Wlan.Dot11Ssid ssid)
        {
            return Encoding.ASCII.GetString( ssid.SSID, 0, (int) ssid.SSIDLength );
        }
         
        static int Main( string[] args )
        {
            
            System.Diagnostics.Debug.Listeners.Clear();
            System.Diagnostics.Debug.Listeners.Add(
               new System.Diagnostics.TextWriterTraceListener(Console.Out));
            int control = 0;
            //variable control retorno
            int retorno = 0;
            Debug.WriteLine("**DeBUG MODe!**");
            
            if (args.Length == 1)
            {
                switch (args[0])
                {

                    case "-connect":
                        control = 1;
                        break;
                    case "-list":
                        control = 2;
                        break;
                }
            }

            if(control==1){
                try
                {
                                //variable que indica proceso existoso = 1 o fallido = 0
            Debug.WriteLine("**Iniciando Auto Wlan Connection**");
            bool estadoConexion = false;
            //Clase WLAN
            WlanClient client = new WlanClient();

            //buscar dispositivo WLAN
            if (client.Interfaces.Length > 0 )
            {
                Debug.WriteLine("");
                Debug.WriteLine("   Detectado(s) "+client.Interfaces.Length.ToString()+" dispositivo(s) WLAN");
                //para cada uno de los dispositivos WLAN disponibles.
                foreach (WlanClient.WlanInterface wlanIface in client.Interfaces)
                {
                    Debug.WriteLine("   Procesando dispositivo: "+wlanIface.InterfaceName);
                    if (wlanIface.NetworkInterface.OperationalStatus == System.Net.NetworkInformation.OperationalStatus.Down)
                    {
                         Debug.Write("   Buscando redes");
                         wlanIface.Scan();
                         Thread.Sleep(2000);
                         Debug.Write(".");
                         Thread.Sleep(2000);
                         Debug.Write(".");
                         Thread.Sleep(2000);
                         Debug.WriteLine(".");
                         
                        //busca todas las redes WLAN con seguridad.
                         Debug.WriteLine("  Buscando redes con seguridad configuradas:");
                         Debug.WriteLine("");
                         Wlan.WlanAvailableNetwork[] networks = wlanIface.GetAvailableNetworkList(NativeWifi.Wlan.WlanGetAvailableNetworkFlags.IncludeAllAdhocProfiles);
                         

                        foreach (Wlan.WlanAvailableNetwork network in networks)
                        {
                            string nombre="";
                            if (network.dot11DefaultCipherAlgorithm != Wlan.Dot11CipherAlgorithm.None && network.flags==NativeWifi.Wlan.WlanAvailableNetworkFlags.HasProfile)
                            {
                                nombre = network.profileName;
                                Debug.WriteLine("   Encontrada:" + nombre+". Intentando conexion (t-out: 20 seg)");
                                
                                estadoConexion = wlanIface.ConnectSynchronously(Wlan.WlanConnectionMode.Profile, Wlan.Dot11BssType.Any, nombre, 20000, nombre);
                                if (estadoConexion == true)
                                {
                                    retorno = 1;
                                    Debug.WriteLine("   Conexion exitosa! (r=1)");
                                }
                                else
                                {
                                    Debug.WriteLine("   Conexion fallida");

                                }
                            }
                        }

                        if (retorno==0)
                        {
                            //prueba conexiones sin seguridad
                            Debug.WriteLine("");
                            Debug.WriteLine("Buscando redes OPEN:");
                            networks = wlanIface.GetAvailableNetworkList(NativeWifi.Wlan.WlanGetAvailableNetworkFlags.IncludeAllAdhocProfiles);
                            
                            foreach (Wlan.WlanAvailableNetwork network in networks)
                            {
                                if (network.dot11DefaultCipherAlgorithm == Wlan.Dot11CipherAlgorithm.None && retorno==0)
                                {
                                    Debug.WriteLine("   Encontrada:" + GetStringForSSID(network.dot11Ssid) + ". Intentando conexion (t-out: 30 seg)");
                                    string tipo = "";
                                    if (network.dot11BssType==NativeWifi.Wlan.Dot11BssType.Infrastructure)
                                    {
                                        tipo = "ESS";
                                    }
                                    else
                                    {
                                        tipo = "IBSS";
                                    }

                                    string prof = "<?xml version=\"1.0\"?><WLANProfile xmlns=\"http://www.microsoft.com/networking/WLAN/profile/v1\">"+
                                        "<name>"+GetStringForSSID(network.dot11Ssid)+"</name><SSIDConfig><SSID><name>"+GetStringForSSID(network.dot11Ssid)+"</name>"+
                                        "</SSID><nonBroadcast>false</nonBroadcast></SSIDConfig><connectionType>"+tipo+"</connectionType>"+
                                        "<connectionMode>manual</connectionMode><MSM><security><authEncryption>"+
                                        "<authentication>open</authentication><encryption>none</encryption><useOneX>false</useOneX>"+
                                        "</authEncryption></security></MSM></WLANProfile>";
                                      
                                        estadoConexion = wlanIface.ConnectSynchronously(Wlan.WlanConnectionMode.TemporaryProfile, Wlan.Dot11BssType.Any, prof, 30000, GetStringForSSID(network.dot11Ssid));

                                        if (estadoConexion==true)
                                        {
                                            retorno = 1;
                                            Debug.WriteLine("   Conexion exitosa! (r=1)");
                                        }
                                        else
                                        {
                                            Debug.WriteLine("   Conexion fallida");

                                        }
                                 
                                }
                            }



                        }

                    }else
                	{
                        Debug.WriteLine("   Dispositivo ya posee conexion activa. (r=3)");
                        retorno =3;
                	}
                }
            }
            else
            {
                Debug.WriteLine("   0 Dispositivos WLAN detectados");
                retorno = 0;
            }

            Debug.WriteLine("");
            Debug.WriteLine("Retorno:" + retorno.ToString());
                }
                catch (Exception e)
                {
                    Console.WriteLine("Error: "+e.Message);
                }

            }

            

            if (control==2)
            {
                try
                {
                    Debug.WriteLine("**Iniciando: Listado WLAN**");
                    WlanClient client = new WlanClient();

                    //buscar dispositivo WLAN
                    if (client.Interfaces.Length > 0)
                    {
                        Debug.WriteLine("");
                        Debug.WriteLine("   Detectado(s) " + client.Interfaces.Length.ToString() + " dispositivo(s) WLAN");
                        //para cada uno de los dispositivos WLAN disponibles.
                        foreach (WlanClient.WlanInterface wlanIface in client.Interfaces)
                        {
                            Debug.WriteLine("   Procesando dispositivo: " + wlanIface.InterfaceName);
                            List<string> redes = new List<string>();
                            Debug.Write("   Buscando redes");
                            wlanIface.Scan();
                            Thread.Sleep(2000);
                            Debug.Write(".");
                            Thread.Sleep(2000);
                            Debug.Write(".");
                            Thread.Sleep(2000);
                            Debug.WriteLine(".");

                            //busca todas las redes WLAN con seguridad.
                            Debug.WriteLine("");
                            Wlan.WlanBssEntry[] networks = wlanIface.GetNetworkBssList();
                            StringBuilder sbRedes = new StringBuilder();

                            // sbRedes.AppendLine("{\"redes\": {\"listado\": {\"red\": [");

                            string ssid, calidad, mac, dbm, canal;
                            foreach (Wlan.WlanBssEntry network in networks)
                            {
                                // Console.WriteLine("Found WEP network with SSID {0}.", GetStringForSSID(network.dot11Ssid));
                                byte[] macAddr = network.dot11Bssid;
                                var macAddrLen = (uint)macAddr.Length;
                                var str = new string[(int)macAddrLen];
                                for (int i = 0; i < macAddrLen; i++)
                                {
                                    str[i] = macAddr[i].ToString("x2");
                                }
                                mac = string.Join("-", str);
                                ssid = GetStringForSSID(network.dot11Ssid);
                                calidad = network.linkQuality.ToString();
                                dbm = network.rssi.ToString();
                                canal = network.chCenterFrequency.ToString();
                                sbRedes.AppendLine("{\"mac_address\": \"" + mac + "\", \"ssid\": \"" + ssid + "\", \"signal_strength\": \"" + dbm + "\", \"channel\": \"" + canal + "\", \"signal_to_noise\": \"" + calidad + "\"},");
                            }
                            // sbRedes.AppendLine("]}}}");
                            Console.WriteLine(sbRedes.ToString(0,sbRedes.Length -3));
                                //.sub(sbRedes.Length - 2, sbRedes.Length-1));

                        }
                    }

                }
                catch (Exception e)
                {
                    Console.WriteLine("Error: " + e.Message);
                }
                
            }

            return retorno;

           
        }

        
    }
}
